"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Row = void 0;
const react_1 = __importStar(require("react"));
const log_1 = require("./common/log");
const env_1 = require("./common/env");
function Row({ name, item, onEdit, onDelete }) {
    const db = env_1.env.db;
    const validation = env_1.env.validation;
    const dbTable = react_1.useMemo(() => db[name], [name]);
    const fields = react_1.useMemo(() => validation.getOwnFields(name), [name]);
    // FIXME quick clicks
    const handleDelete = async () => {
        try {
            const id = item.id;
            log_1.log('[Row.handleDelete]', id);
            await dbTable.delete(id);
            onDelete && onDelete(id);
        }
        catch (error) {
            alert(error.message);
        }
    };
    return react_1.default.createElement("tr", { key: item.id + '' },
        react_1.default.createElement("td", null,
            react_1.default.createElement("i", { className: 'icon delete', onClick: handleDelete }),
            react_1.default.createElement("i", { className: 'icon edit', onClick: () => onEdit && onEdit() })),
        fields.map(f => react_1.default.createElement("td", { key: f },
            react_1.default.createElement(Field, { table: name, item: item, f: f }))));
}
exports.Row = Row;
function Field({ table, item, f }) {
    const validation = env_1.env.validation;
    const ps = react_1.useMemo(() => validation.getOwnProperties(table), [table]);
    const type = ps[f].type;
    switch (type) {
        case 'number':
        case 'integer':
        case 'string':
            return react_1.default.createElement(react_1.default.Fragment, null, item[f]);
        case 'boolean':
            return react_1.default.createElement("input", { type: 'checkbox', checked: item[f], disabled: true, className: 'type-' + type });
        case 'object':
        case 'array':
            return react_1.default.createElement(react_1.default.Fragment, null, JSON.stringify(item[f]));
        case 'null':
            return react_1.default.createElement(react_1.default.Fragment, null, "null");
    }
}
